﻿namespace HeuristicLab.BenchmarkSuite.Problems {

  public class CountOdds : BenchmarkSuiteDataDescriptor {
    private const string name = "Count Odds";
    private const string fileName = "CountOdds.csv";
    private const string description = "";

    protected override string FileName { get { return fileName; } }
    public override string Name { get { return name; } }
    public override string Description { get { return description; } }
    protected override int InputArgumentCount { get { return 1; } }
    protected override int OutputArgumentCount { get { return 1; } }

    public override Data CreateProblemData() {
      return new Data {
        Name = Name,
        Description = Description,
        Examples = CloneExamples(),
        BestResult = 0,
        WorstResult = 50,
        InputArgumentTypes = new[] { ExampleArgumentType.IntegerCollection },
        OutputArgumentTypes = new[] { ExampleArgumentType.Integer },
        OriginalTestCount = 2000,
        OriginalTrainingCount = 200,
        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.IntegerVector,
        EvalLimit = 1500,
        MaxSize = 500,
      };
    }

    protected override Example ParseExample(string[] input, string[] output) {
      return new Example {
        InputArgs = input,
        OutputArgs = output,
        InputInt = ExampleArgumentConverter.ConvertIntegers(input[0]),
        OutputInt = ExampleArgumentConverter.ConvertIntegers(output[0])
      };
    }
  }
}
